fan.fes2vector3d = {};
fan.fes2vector3d.V3d = fan.sys.Obj.$extend(fan.sys.Obj);
fan.fes2vector3d.V3d.prototype.$ctor = function()
{
  fan.sys.Obj.prototype.$ctor.call(this);
  var $this = this;
}
fan.fes2vector3d.V3d.prototype.$typeof = function() { return fan.fes2vector3d.V3d.$type; }
fan.fes2vector3d.V3d.make = function(x,y,z) {
  var self = new fan.fes2vector3d.V3d();
  fan.fes2vector3d.V3d.make$(self,x,y,z);
  return self;
  }
fan.fes2vector3d.V3d.make$ = function(self,x,y,z)
{
  self.m_x = x;
  self.m_y = y;
  self.m_z = z;
  return;
}
fan.fes2vector3d.V3d.prototype.plus = function(that)
{
  return fan.fes2vector3d.V3d.make(fan.sys.Float.plus(this.m_x,that.m_x),fan.sys.Float.plus(this.m_y,that.m_y),fan.sys.Float.plus(this.m_z,that.m_z));
}
fan.fes2vector3d.V3d.prototype.negate = function()
{
  return fan.fes2vector3d.V3d.make(fan.sys.Float.negate(this.m_x),fan.sys.Float.negate(this.m_y),fan.sys.Float.negate(this.m_z));
}
fan.fes2vector3d.V3d.prototype.minus = function(that)
{
  return fan.fes2vector3d.V3d.make(fan.sys.Float.minus(this.m_x,that.m_x),fan.sys.Float.minus(this.m_y,that.m_y),fan.sys.Float.minus(this.m_z,that.m_z));
}
fan.fes2vector3d.V3d.prototype.multFloat = function(n)
{
  return fan.fes2vector3d.V3d.make(fan.sys.Float.mult(this.m_x,n),fan.sys.Float.mult(this.m_y,n),fan.sys.Float.mult(this.m_z,n));
}
fan.fes2vector3d.V3d.prototype.multInt = function(n)
{
  return this.multFloat(fan.sys.Num.toFloat(fan.sys.ObjUtil.coerce(n,fan.sys.Num.$type)));
}
fan.fes2vector3d.V3d.prototype.divFloat = function(n)
{
  return fan.fes2vector3d.V3d.make(fan.sys.Float.div(this.m_x,n),fan.sys.Float.div(this.m_y,n),fan.sys.Float.div(this.m_z,n));
}
fan.fes2vector3d.V3d.prototype.dot = function(that)
{
  return fan.sys.Float.plus(fan.sys.Float.plus(fan.sys.Float.mult(this.m_x,that.m_x),fan.sys.Float.mult(this.m_y,that.m_y)),fan.sys.Float.mult(this.m_z,that.m_z));
}
fan.fes2vector3d.V3d.prototype.squared = function()
{
  return this.dot(this);
}
fan.fes2vector3d.V3d.prototype.magnitude = function()
{
  return fan.sys.Float.sqrt(this.squared());
}
fan.fes2vector3d.V3d.prototype.cross = function(that)
{
  return fan.fes2vector3d.V3d.make(fan.sys.Float.minus(fan.sys.Float.mult(this.m_y,that.m_z),fan.sys.Float.mult(this.m_z,that.m_y)),fan.sys.Float.minus(fan.sys.Float.mult(this.m_z,that.m_x),fan.sys.Float.mult(this.m_x,that.m_z)),fan.sys.Float.minus(fan.sys.Float.mult(this.m_x,that.m_y),fan.sys.Float.mult(this.m_y,that.m_x)));
}
fan.fes2vector3d.V3d.prototype.abs = function()
{
  return this.magnitude();
}
fan.fes2vector3d.V3d.prototype.size = function()
{
  return this.magnitude();
}
fan.fes2vector3d.V3d.prototype.isUnit = function()
{
  return fan.sys.ObjUtil.equals(this.magnitude(),fan.sys.Float.make(1.0));
}
fan.fes2vector3d.V3d.prototype.distance = function(that)
{
  return this.minus(that).magnitude();
}
fan.fes2vector3d.V3d.prototype.equals = function(that)
{
  if (!fan.sys.ObjUtil.is(that,fan.fes2vector3d.V3d.$type))
  {
    return false;
  }
  ;
  var other = fan.sys.ObjUtil.coerce(that,fan.fes2vector3d.V3d.$type);
  return (fan.sys.ObjUtil.equals(this.m_x,other.m_x) && fan.sys.ObjUtil.equals(this.m_y,other.m_y) && fan.sys.ObjUtil.equals(this.m_z,other.m_z));
}
fan.fes2vector3d.V3d.prototype.compare = function(that)
{
  var other = fan.sys.ObjUtil.coerce(that,fan.fes2vector3d.V3d.$type);
  return fan.sys.ObjUtil.compare(this.magnitude(),fan.sys.ObjUtil.coerce(other.magnitude(),fan.sys.Obj.$type));
}
fan.fes2vector3d.V3d.prototype.hash = function()
{
  return fan.sys.Int.xor(fan.sys.Int.xor(fan.sys.Float.hash(this.m_x),fan.sys.Float.hash(this.m_y)),fan.sys.Float.hash(this.m_z));
}
fan.fes2vector3d.V3d.prototype.toStr = function()
{
  return fan.sys.Str.plus(fan.sys.Str.plus(fan.sys.Str.plus(fan.sys.Str.plus(fan.sys.Str.plus(fan.sys.Str.plus("(",fan.sys.ObjUtil.coerce(this.m_x,fan.sys.Obj.$type.toNullable())),","),fan.sys.ObjUtil.coerce(this.m_y,fan.sys.Obj.$type.toNullable())),","),fan.sys.ObjUtil.coerce(this.m_z,fan.sys.Obj.$type.toNullable())),")");
}
fan.fes2vector3d.V3d.static$init = function()
{
  fan.fes2vector3d.V3d.m_zero = fan.fes2vector3d.V3d.make(fan.sys.Float.make(0.0),fan.sys.Float.make(0.0),fan.sys.Float.make(0.0));
  return;
}
fan.fes2vector3d.V3d.prototype.m_x = fan.sys.Float.make(0);
fan.fes2vector3d.V3d.prototype.m_y = fan.sys.Float.make(0);
fan.fes2vector3d.V3d.prototype.m_z = fan.sys.Float.make(0);
fan.fes2vector3d.V3d.m_zero = null;
fan.fes2vector3d.$pod = fan.sys.Pod.$add('fes2vector3d');
with (fan.fes2vector3d.$pod)
{
  fan.fes2vector3d.V3d.$type = $at('V3d','sys::Obj',[],{'sys::Serializable':"",'sys::Js':""},8194);
  fan.fes2vector3d.V3d.$type.$af('x',73730,'sys::Float',{}).$af('y',73730,'sys::Float',{}).$af('z',73730,'sys::Float',{}).$af('zero',106498,'fes2vector3d::V3d',{}).$am('make',8196,'sys::Void',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('x','sys::Float',false),new fan.sys.Param('y','sys::Float',false),new fan.sys.Param('z','sys::Float',false)]),{}).$am('plus',8192,'sys::This',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','fes2vector3d::V3d',false)]),{'sys::Operator':""}).$am('negate',8192,'sys::This',fan.sys.List.make(fan.sys.Param.$type,[]),{'sys::Operator':""}).$am('minus',8192,'sys::This',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','fes2vector3d::V3d',false)]),{'sys::Operator':""}).$am('multFloat',8192,'sys::This',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('n','sys::Float',false)]),{'sys::Operator':""}).$am('multInt',8192,'sys::This',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('n','sys::Int',false)]),{'sys::Operator':""}).$am('divFloat',8192,'sys::This',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('n','sys::Float',false)]),{'sys::Operator':""}).$am('dot',8192,'sys::Float',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','fes2vector3d::V3d',false)]),{}).$am('squared',8192,'sys::Float',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('magnitude',8192,'sys::Float',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('cross',8192,'fes2vector3d::V3d',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','fes2vector3d::V3d',false)]),{}).$am('abs',8192,'sys::Float',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('size',8192,'sys::Float',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('isUnit',8192,'sys::Bool',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('distance',8192,'sys::Float',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','fes2vector3d::V3d',false)]),{}).$am('equals',271360,'sys::Bool',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','sys::Obj?',false)]),{}).$am('compare',271360,'sys::Int',fan.sys.List.make(fan.sys.Param.$type,[new fan.sys.Param('that','sys::Obj',false)]),{}).$am('hash',271360,'sys::Int',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('toStr',271360,'sys::Str',fan.sys.List.make(fan.sys.Param.$type,[]),{}).$am('static$init',165890,'sys::Void',fan.sys.List.make(fan.sys.Param.$type,[]),{});
  m_meta = fan.sys.Map.make(fan.sys.Str.$type, fan.sys.Str.$type);
  m_meta.set("pod.name", "fes2vector3d");
  m_meta.set("pod.version", "0.0.1");
  m_version = fan.sys.Version.fromStr("0.0.1");
  m_meta.set("pod.depends", "sys 1.0+");
  m_meta.set("pod.summary", "Small library of 3d vectors ");
  m_meta.set("pod.isScript", "false");
  m_meta.set("fcode.version", "1.0.51");
  m_meta.set("build.host", "algedonic");
  m_meta.set("build.user", "fraya");
  m_meta.set("build.ts", "2017-06-04T15:26:17.301+02:00 Madrid");
  m_meta.set("build.compiler", "1.0.69");
  m_meta.set("build.platform", "linux-x86_64");
  m_meta.set("license.name", "MIT");
  m_meta.set("pod.docSrc", "true");
  m_meta.set("pod.native.dotnet", "false");
  m_meta.set("proj.name", "fes2vector3d");
  m_meta.set("proj.uri", "https://bitbucket.org/fernandoraya/fes2vector3d");
  m_meta.set("pod.docApi", "true");
  m_meta.set("pod.native.java", "false");
  m_meta.set("vcs.uri", "https://bitbucket.org/fernandoraya/fes2vector3d");
  m_meta.set("pod.native.jni", "false");
  m_meta.set("vcs.name", "mercurial");
  m_meta.set("pod.native.js", "false");
  m_meta = m_meta.toImmutable();
}
fan.fes2vector3d.V3d.static$init();
//# sourceMappingURL=/pod/fes2vector3d/fes2vector3d.js.map
